/*view() and oview() - almost all programmers know how these works. Simply by doing this:

view(usr)<<"Hi"

everyone that the user can see will get that message. Unfortunately, for say procs, people use
the inproper method, view(). When using say, hearers() would be more appropiate. hearers() will
return everyone that can hear within the distance given. For example,

mob
	verb
		say(T as text)
			hearers(5,usr)<<"[T]"

will cause everyone within 5 tiles of usr who can hear usr to see [T].

Now then, what if you want to mix this up a little bit. Let's say you have a blind enemy. Going
with basic assumption, this enemy will either be strong or can hear very easily. This library
will supply you with a hear() proc to allow you to achieve something like this. For those of you
who don't know, a library is meant to be included within a game, like so:

#include <demon_f0rce\hear\Hear.dme>

copy and paste that line into your game, and you can use the procs provided in this library.

Also; libraries are only meant to be included, whereas demos you look at and learn off of. I
will include single-line breaks and explain this code so people can understand it.

Deafness:

Version 2, it was pointed out to me that currently hear() == hearers(). So, I've added in
deafness, which will make hear() != hearers(). This will also apply modification to hearers().*/

mob/var
	deafness = 0	//deafness. I'm sure this doesn't need explaining to its use. However...

					//A value of 1 = Can still mainly hear (if hear(usr,10), it becomes
					//8 tiles instead.)

					//A value of 2 = Can still sorta hear (if hear(usr,10), it becomes
					//6 tiles instead.)

					//A value of 3 = Is having trouble listening (if hear(usr,10), it becomes
					//4 tiles instead.)

					//A value of 4 = Is becoming deaf (if hear(usr,10), it becomes 2 tiles
					//instead.)

					//A value of 5 = Completely deaf.


mob/proc							//Define as a mob's proc.
	hear(mob/center,dist=text2num(world.view)/20)//Basic structure.
									//You must always supply a center, however
									//if there is no distance, hear will automaically calculate
									//distance to be equal to whoever's in range of center.
									//Take ntoe that center must be a mob or you'll get a
									//compile error.
		var/hear = list()			//Makes a list, this will come back soon...
		var/dist2 = round(dist - ((dist/5) * center.deafness))	//Using this formula will
																//cause the values listed
																//above to always be true

		for(var/mob/M in range(dist2,center))	//Loop through all mob's in the distance

			for(var/mob/M2 in hearers(M))		//Loop through all mob's who can hear M.

				if(M2 == center)					//If center is one of said hearers...
					hear += M					//Add M to the list.

		return hear					//Once we've done all this, return hear back to the caller
									//So that you can do what you want with who center can hear.

//And since you all will want an ohear for those who center can hear who isn't on top of him,
//we'll simply use the same as seen above, just replacing range() with orange() and hearers()
//with ohearers()

mob/proc
	ohear(mob/center,dist=text2num(world.view))
		var/hear = list()
		if(!dist)
			dist = text2num(world.view)
		var/dist2 = round(dist - ((dist/5) * center.deafness))
		for(var/mob/M in orange(dist2,center))
			for(var/mob/M2 in ohearers(M))
				if(M2 == center)
					hear += M
		return hear
mob/proc
	new_hearers(mob/center,dist=text2num(world.view))//We can't overwrite hearers(),
													 //so let's make our own.
		var/hearers = list()		//We get our list again.
		for(var/mob/M in range(dist,center))
			var/dist2 = round(dist - ((dist/5) * M.deafness)) //Calculate what we lose through
															  //deafness.
			for(var/mob/M2 in hearers(dist2,M))	//We call hearers() here so we get exactness.
				if(M2 == center)
					hearers += M
		return hearers
//And once again, I grant you your ohearers proc...

mob/proc
	new_ohearers(mob/center,dist=text2num(world.view))
		var/hearers = list()
		for(var/mob/M in orange(dist,center))
			var/dist2 = round(dist - ((dist/5) * M.deafness))
			for(var/mob/M2 in ohearers(dist2,M))
				if(M2 == center)
					hearers += M
		return hearers